#! /usr/bin/python

def get_news_tuple():
    items =(("New Web Page: 30/06/05","Finally a decent web page for GtkBook project",""),
            ("Widget a Day: 28/06/05","Muthu has started to write 1 widget-a-day, to complete, the GtkBook project, see $URL for more news"," http://advogato.org/person/gnumuthu/diary.html?start=6"),
            ("Wiki: June 2005","A community workspace at GNOME project: $URL",
             "http://live.gnome.org/GtkBook/")
            );
    return items


def get_header_string():
    return """<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head><meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="description" content="GtkBook project">
<meta name="keywords" content="GtkBook,GTK+,Gtk,GUI,toolkit,GNOME,documentation,
free book,GtkBook team,GUI design,examples,tutorials,Free Software,GNU">
<title>GtkBook: Free documentation for GTK+</title>
</head>
<body>
<!-- Banner -->
<IMG src="./images/banner.png" alt="GTK Book Project banner" /><BR />
<!-- Generate Title Bar of Links -->""" + get_title_link_string()

def get_title_link_string():
    title_links = ( ("Home","index.html"),
                    ("Links","links.html"),
                    ("Download","download.html"),
                    ("License","license.html"),
                    ("News","news.html"),
                    ("Contribute","contribute.html"),
                    ("Feedback","feedback.html"),
                    ("Contact","contact.html"),
                    ("About","about.html"),
                    ("TodaysWidget","widgetaday.html")
                    )
    
    datastring="<HR />"
    datastring=datastring+"<TABLE width=\"100%\"><TR>"
    for link in title_links:
        datastring=datastring+"<TD><A HREF=\"./"+link[1]+"\">"+link[0]+"</A></TD>"
        
    datastring=datastring+ "</TR></TABLE>"
    datastring=datastring+"<HR />"
        
    return datastring

def get_footer_string():
    images=(("GNU project","gnome-emacs.png","www.gnu.org"),
            ("GTK+ project","gtk-logo-rgb.png","www.gtk.org"),
            ("GNOME project","gnome-logo-icon-transparent.png","www.gnome.org"),
            ("Linux","gnome-term-linux2.png","www.kernel.org"),
            ("Inkscape","inky.png","www.inkscape.org"),
            ("Creative Commons","./deed_002.gif","creativecommons.org"));
     
    imgdir = "./images/"
    
    imgstr="<TR>"
    nextrow="<TR>"
    for image in images:
        imgstr=imgstr+"<TD><A HREF=\"http://"+image[2]+"\">\n"
        nextrow=nextrow+"<TD>"+image[0]+"</TD>"
        imgstr=imgstr+"<IMG SRC=\""+imgdir+image[1]+"\" alt=\""+image[0]+"\" /></A>"
        imgstr=imgstr+"</TD>\n"
    nextrow=nextrow+"</TR>\n"
    imgstr=imgstr+"</TR>\n"

    imgstr=imgstr+nextrow;
    
    
    footstr="""<TR><TD>&copy; GtkBook team, 2005. Please mirror the site as you wish. Graphics, content may also be freely used under Creative Commons License.</TD>
    <A Href=\"http://creativecommons.org/licenses/by-sa/2.5/\">License</A></TD></TR>\n
<TR><TD>
<!-- Creative Commons License -->
<a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.gif" /></a><br />
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.
<!-- /Creative Commons License -->


<!--

<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
   <license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
   <requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
</License>

</rdf:RDF>

-->
</TD></TR> """
        
    return "<HR />\n<TABLE width=\"100%\">\n"+imgstr+"</TABLE>"+footstr+"\n</body>\n</html>"


def get_index_page():
    news=get_news_tuple()[0];
    nstr="<P>News Flash: <P><B>"+news[0]+"</B>:"+news[1].replace("$URL","[See NEWS section]")
    datastring=nstr + """<HR />Start contributing to our <FONT color="red">Widget a Day</Font> section.<BR />
     <OL>
 <LI>Table of Contents <A href="./contents.html">Contents</A></LI>
<LI>Widget Status <A href="./widget.html">Widget</A></LI>
</OL>
    <TABLE align="center" bgcolor="ivory" width="75%">
    <TR>
    <TD>
    <P>    The GtkBook is an ambitious project that aims to create 
    new useable and world class documentation for the Gtk
    tool kit, in code as well as concepts.
    
    <P> Its is aimed to be useful to the hacker as well as
    the novice in their attempt to master the nuances
    of the Gtk toolkit to develop better free-software
    faster and easier.
    
    <P> The documents are to be written in simple
    english and are expected to be translated to many languages
    as soon as the project nears initial release stages.
    
    <P>Gtk is still the most under-documented toolkit thats patronized
    widely and rightly at that. Its the initial learning curve
    that we target in this book and we have to overcome for
    any serious programmer to contribute to the Gtk world.
    </TD></TR></TABLE>
    """
    return datastring

def get_links_page():
    links=(("License","creativecommons.org/licenses/by-sa/2.5/"),
           ("HomePage","gtkbook.sf.net"),
           ("GTK Project","www.gtk.org"),
           ("Mailing Lists Sign Up","www.freelists.org/list/gtk-book"),
           ("Mailing Lists Archive","www.freelists.org/archives/gtk-book"),
           )
    
    datastring="<!-- Content -->"
    datastring=datastring+ "<OL>"
    for link in links:
        datastring=datastring+"<LI><A HREF=\"http://"+link[1]+"\">"+link[0]+"</A></LI>"
    datastring=datastring+"</OL>"

    return datastring


def get_download_page():
    downloads=(("GtkBook [old, Tarball]","./GtkBook.tar.gz"),
	       ("Gtk TextView tutorial","./archives/gtktext-0.3.tar.gz"),
               ("Image processing Guide [HTML tarball]","./improc.tgz"),
               ("Image processing Guide [PDF]","./improc.pdf"),
               ("Image processing Guide [Browsable]","./improc/index.html"),
               ("Example Code for Image Processing","./colors.tgz"),
               ("Source code of website generation s/w","./generate.py"),
               ("Source code of GtkBook logo ","./images/banner.svg"),
               )
    datastring="<!-- Content -->"
    datastring=datastring+ "<OL>"
    for link in downloads:
        datastring=datastring+"<LI><A HREF=\""+link[1]+"\">"+link[0]+"</A></LI>"
    datastring=datastring+"</OL>"

        
    return datastring

def get_license_page():
    lstr="""
    <UL>
  <LI>  Please read this license page carefully, before you can reuse the code,
    documentation, and this work in general.</LI>
  <LI>Please be very careful while
    reusing code, from this Book, as we have taken parts of it from <B>GPL'ed</B>
    programs, and other <B>free licenses</B>, which are applicable to the code.</LI>
   <LI>
    The rest of the code, is however under public domain and indicated.
    </LI>
   </UL>
   
    <H3>License</H3>
    <BR />
    <!--<A href="./Creative Commons Deed.html">Original License</A>-->
    <TABLE bgcolor="ivory" width="100%" border=2>
    <TR>
    <TD>
    
<!--
<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
   <requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
</License>
</rdf:RDF>

-->

<p align="center"><a href="http://creativecommons.org/">Creative Commons</a></p>



<div id="deed">
	<div align="center">
	<img src="Creative%20Commons%20Deed_files/logo_deed.gif" alt="Creative Commons Deed" border="0" height="79" vspace="14" width="280">

	<p><b>Attribution-ShareAlike 2.5 </b></p>

	<div class="text">
        
		<p><strong>You are free:</strong></p>
			<ul>
				<li>to copy, distribute, display, and perform the work</li>
				<li>to make derivative works</li><li>to make commercial use of the work</li>
			</ul>

		<p><strong>Under the following conditions:</strong></p>
	        <div align="center"><table class="draft" border="0" cellpadding="4" cellspacing="0" width="500">
		<tbody>
                <tr><td><img src="Creative%20Commons%20Deed_files/deed.gif" alt="by" align="left" border="0" hspace="4"></td><td align="left"><div class="tiny"><strong>Attribution</strong>. You must attribute the work in the manner specified by the author or licensor.</div></td></tr>
                
                <tr><td><img src="Creative%20Commons%20Deed_files/deed_002.gif" alt="sa" align="left" border="0" hspace="4"></td><td align="left"><div class="tiny"><strong>Share Alike</strong>.
If you alter, transform, or build upon this work, you may distribute
the resulting work only under a license identical to this one.</div></td></tr>
                </tbody></table></div>
		
    <ul>
    <li>For any reuse or distribution, you must make clear to others the license terms of this work.</li>
    <li>Any of these conditions can be waived if you get permission from the copyright holder.</li>
    </ul>

<p style="margin-top: 40px;" align="center"><strong>Your fair use and other rights are in no way affected by the above.</strong></p>

		
		<p align="center">
		This is a human-readable summary of the <a href="http://creativecommons.org/licenses/by-sa/2.5/legalcode" class="fulltext">Legal Code (the full license)</a>.
                </p>
		
		
			<div align="center"><a href="http://creativecommons.org/licenses/disclaimer-popup?lang=en" onclick="window.open('/licenses/disclaimer-popup?lang=en', 'characteristic_help', 'width=375,height=300,scrollbars=yes,resizable=yes,toolbar=no,directories=no,location=yes,menubar=no,status=yes');return false;">Disclaimer</a> <a href="http://creativecommons.org/licenses/disclaimer-popup?lang=en" onclick="window.open('/licenses/disclaimer-popup?lang=en', 'characteristic_help', 'width=375,height=300,scrollbars=yes,resizable=yes,toolbar=no,directories=no,location=yes,menubar=no,status=yes');return false;"><img src="Creative%20Commons%20Deed_files/popup.gif" alt="disclaimer" border="0" height="13" width="15"></a></div>
		
			<p> </p>
		</div>
	</div>
</div>

<div id="deed" style="text-align: center;">
This page is available in the following languages:
<br>

<a href="http://creativecommons.org/licenses/by-sa/2.5/deed.ca" title="Català" hreflang="ca" rel="alternate" lang="ca">Català</a>

<a href="http://creativecommons.org/licenses/by-sa/2.5/deed.de" title="Deutsch" hreflang="de" rel="alternate" lang="de">Deutsch</a>

<a href="http://creativecommons.org/licenses/by-sa/2.5/deed.en" title="English" hreflang="en" rel="alternate" lang="en">English</a>

<a href="http://creativecommons.org/licenses/by-sa/2.5/deed.en_CA" title="English (CA)" hreflang="en_CA" rel="alternate" lang="en_CA">English (CA)</a>

<a href="http://creativecommons.org/licenses/by-sa/2.5/deed.en_GB" title="English (GB)" hreflang="en_GB" rel="alternate" lang="en_GB">English (GB)</a>

</div>


<p>
<a href="http://creativecommons.org/learn/licenses">Learn how to distribute your work using this license</a>
</p>
    </TD></TR></TABLE>
    
    We are using the <B>creative commons</B> license, with share and
    share alike policy.<BR />
    You can find the exact license here:
    <A Href=\"http://creativecommons.org/licenses/by-sa/2.5/legalcode\">License</A>
    <BR />

    <H3>Programs</H3>
    Parts of the example code, which are taken from other free software
    programs, are being distributed under the same license, of the original
    program, we have taken the code from. eg: In GPL programs, used as examples,
    we make that code reuseable under GPL terms only. Such code and license
    will be explicitly indicated.

    <P> The rest of the code/examples in the GtkBook will be released in
    public domain. This will also be indicated explicitly.

    <P> Before using ambiguously licensed/license not mentioned,
    code/exmples in your programs,   that you will/will-not publish,
    please ask before using/re-using the  code.

    <H3>Code, Images, Text</H3>
    All these Code, Images, Text, with  exceptions noted above, may be
    distributed under the Creative Commons License shown above.    
    
    """
    datastring=lstr
    
    return datastring

def get_news_page():
    #add news items  to top.
    items=get_news_tuple()
    data="<OL>"
    for item in items:
        data=data+"<LI><B>"+item[0]+"</B><BR />"
        data=data+item[1].replace("$URL","<A HREF=\""+item[2]+"\">URL</A>")+"</LI>"
    data=data+"</OL>"
        
    datastring="<B>News Page</B>"+data
    return datastring

def get_contribute_page():
    cstr="""
    <H5>General Guidelines</H5>
    You are mostly a programmer, artist or a technical writer
    thinking if you must join this project. This page exists
    to help you understand in what capacity you can best help
    the GtkBook project, and be  a part of the winning team.
    
    
    <P>You can contribute to this project, in any of the following roles,
    <UL>
    <LI> Programmer/Technical writer: code [WRITER] <BR />
    You must be a competent programmer, and familiar with the
    GTK+ toolkit. You can pickup tasks, and widgets to document on.
    Please see the TODO list for more details.

    You may also be a Technical writer/programmer who can supervise the
    editing of the manuscript for technical correctness, and producing
    a cohesive book.

    <P>[Vacancy for 10+ people]

    <LI> Technical Editor / Reviewer: code [EDITOR] <BR />
    You must be a native english speaker, or well versed with
    the English language usage; Also you should communicate
    with the GtkBook team with periodic reviews on the written
    material. You should also wish to speak with the team,
    and provide templates, writing guidelines, and good-english
    usage tips to the team. The role is motivational, and preventive;
    to eliminate mistakes before they can happen. Once the whole
    manuscript is done, you can do the real job of editing for
    language, style and usage.

    <P>[Vacancy for 2 people]
    
    <LI> Promotionals/Public Relations/Publicity Manager: code [PR]<BR />
    This role requires, an expert/experienced PR person who can talk to
    various preoject leaders in the Free Software community, and gather
    momentum and visibility for the GtkBook project. We would also like
    you to do recruit/promote people to join the project, as users
    in various capacities [contributors].

    <P>[This vacancy is for one person.]
    
    <LI> Layout designer, Graphic artist. : code [LAYOUT] <BR />
    Graphic designer, will be a person, to lookafter the formatting
    layout, and presentation of the whole book. We would like you
    to be experienced in DocBook, or learn it, LaTeX, HTML and
    other presentation standards. You must take care of presenting
    the GtkBook, in its various stages, before and after completion,
    in formats for the user to download or distribute. You must
    provide atleast PDF, HTML, PS, LaTeX, copies of the document,
    for which, you must DocBook'ize the whole GtkBook, in SGML.

    <P>[Vacancy for 4 or more people]
    </UL>

    <P>Once you have decided how to contribute, doing the actual stuff
    is rather easy.

    <H5>Joining the Project</H5>
    <UL>
    <LI>Join the mailing lists: <A HREF="http://www.freelists.org/list/gtk-book">Click Here</A>
    <LI>Post a message introduing yourself, your background [optional], and in what
    way you will help the project.
    <LI>Downloads the latest documentation code from <A href="./download.html">this</A> and start working.
    <LI>Once you have something substantial, please postit back to the mailing lists, a;
    <LI>You have made it! <b> your</b> first contribution to GtkBook has been made!
    </OL>

    Thats how its supposed to work.
    Now what are you waiting for? Get to work. For Us!
        
    """
    datastring="<B> Contribute, Join us</B><BR />"+cstr
    
    return datastring

def get_feedback_page():
    
    fstr="""
    <P>Yes! We are interested in hearing what you have to say!
    <UL>
    <LI>Did you like this project?
    <LI>    Do you have any suggstions, on how to do things?
    <LI>    Did you read <B>Contribute </B> section ?
    <LI>    Do you have an unanwered question?
    </UL>
    <HR />
    Fell free to contact us.<BR />
    Please mail Muthiah Annamalai at <B>gnumuthu-at-users-dot-sf-dot-net</B>
    """
    datastring="<H4>Give feedback</H4>"+fstr
    return datastring

def get_contact_page():
    cstr="""
    <P>If you are an <B>Editor of some magazine</B>, <B>publisher</B>,
    and want to <B>publish
    extracts</B>, or <B>publish whole work</B> of the GtkBook team,
    then please contact us,
    Fell free to write to us.<BR />
    mail Muthiah Annamalai at <B>gnumuthu-at-users-dot-sf-dot-net</B>"""
    datastring="Contact GtkBook Team"+cstr
    return datastring

def get_about_page():
    datastring="""I am Muthiah Annamalai, from India.
    Im a GTK+/GNOME hacker, with small contributions
    to projects in GNOME, like Gedit, Inkscape, EOG,
    and Zenity. I also happen to be the project leader,
    and primary author of <B>GtkBook</B><BR />

    <TABLE width="75%" bgcolor="ivory" align="center">
    <TR><TD>
    <H2>Motivations</H2>
    Like most other Free software projects, GtkBook was started
    to scratch onself's itch.
    <OL>
    <LI>Qt & KDE have *<B>Amazing</B>* documents . see docs.kde.org,
    www.trolltech.com, and all those amazing sites out there.
    <LI>So do our rivals M$. msdn.m$.com, Apple developer.apple.com.
    <LI>GTK+ can do with some comprehensive documentation.
    Presently no one stop place. GtkMM docs are great. DevHelp,
     too tries to patch up GNOME with Qt.
    Still focus on GNOME is,<I> look into source code</I>, rather than
     <B>give more documentation</B>.
    <LI>GNOME + ISV, MONO +ISV, MONO-GTK#,  GTK is future toolkit for *NIX.
    Moreover lots of people use GTK+ on MAC, and WINDOWS plaforms.
    <LI> Gtk is simple, plain, fast and easy: iff you understand the basics.
    We will make GTK+ the toolkit of choice for newbies.
    <LI>Lets give them a fight, KDE, Qt, M$, Apple, Java, Sun  et-al,
    lets write amazing docs, too. <I>World class toolkit</I>, now with
    <B>World class documentation</B>.
    </OL>
    </TD></TR>
    </TABLE>
    
    <P>I had in mind, for the past one year or so,
    a book on GTK+, title <B>A Journey through GTK+</B>.
    In fact I've started work on this, and made a 
    community project at <A HREF="http://gtkbook.sf.net">http://gtkbook.sf.net</A>.
    Its very much a work in progress after one of conception, starting June 2004.
    
    <P>Previous examples of my work include an exposition
    on GdkPixbuf, titled <I>Image processing with GTK+</I>
    may be found <A HREF="http://gtkbook.freewebspace.com/imrpoc/">here</A>.
    
    <P>Im also the author of GTK bindings to GNU Octave,
    at <A HREF="http://octave-gtk.sf.net">Octave-GTK</A>"""
    
    return datastring

def get_widgetaday_page():
    widgets = [i.strip() for i in open("widgetaday").readlines()];
    srcpath="./archives/"
    wstr="<OL>"
    for widget in widgets:
        wstr=wstr+"<LI>"+widget+" <A HREF=\""+srcpath+widget+".html\">"+widget+"</A>, <BR /> download tarball <A HREF=\""+srcpath+widget+".tgz\">"+widget+"</A></LI>"
    wstr=wstr+"</ol>"
    datastr="<h4>Widget of the Day</h4>"+wstr
    return datastr

def generate():
    pages = ( (get_index_page,"index.html",),
              (get_links_page,"links.html"),
              (get_download_page,"download.html"),
              (get_license_page,"license.html"),
              (get_news_page,"news.html"),
              (get_contribute_page,"contribute.html"),
              (get_feedback_page,"feedback.html"),
              (get_contact_page,"contact.html"),
              (get_about_page,"about.html"),
	      (get_widgetaday_page,"widgetaday.html")
              )

    header=get_header_string();
    footer=get_footer_string();
    
    for page in pages:
        import string
        print "Generating "+page[1]+"..."
        fp=open(page[1],"w")
        fp.write(header+"\n")
        fp.write(page[0]()+"\n")
        fp.write(footer+"\n")
        fp.close()
    print "\nCompleted "
        
    return

if __name__ == "__main__":
    generate()
